Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr.instruct
Class Copy

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.instruct.Instruction
              net.sf.saxon.expr.instruct.ParentNodeConstructor
                  net.sf.saxon.expr.instruct.ElementCreator
                      net.sf.saxon.expr.instruct.Copy

All Implemented Interfaces:
  Serializable, SourceLocator, LocationProvider, SaxonLocator, EvaluableItem, DivisibleInstruction, TailCallReturner, SequenceIterable, InstructionInfo, Locator

    public class Copy

extends ElementCreator

Handler for xsl:copy elements in stylesheet.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.instruct.ElementCreator
`inheritNamespaces, preservingTypes`

Fields inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor
`content`

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, EVENT_FEED_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, PROCESS_METHOD, PUSH_SELECTION, staticProperties, WATCH_METHOD`

Constructor Summary
`Copy(Expression select, boolean copyNamespaces, boolean inheritNamespaces, SchemaType schemaType, int validation)` Create a shallow copy instruction

Method Summary
`Expression` | `copy()` Copy an expression.
`Item` | `evaluateItem(XPathContext context)` Evaluate as an expression.
`void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
`int[]` | `getActiveNamespaces()` Callback to get a list of the intrinsic namespaces that need to be generated for the element.
`int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
`int` | `getIntrinsicDependencies()` Determine which aspects of the context the expression depends on.
`ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the result of this instruction.
`int` | `getNameCode(XPathContext context, NodeInfo copiedNode)` Callback from ElementCreator when constructing an element
`String` | `getNewBaseURI(XPathContext context, NodeInfo copiedNode)` Get the base URI of a copied element node (the base URI is retained in the new copy)
`Expression` | `getSelectExpression()` Get the expression that selects the node or other item to be copied
`Iterator<Expression>` | `iterateSubExpressions()` Get the immediate sub-expressions of this expression.
`Expression` | `optimize(ExpressionVisitor visitor, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`protected void` | `outputNamespaceNodes(XPathContext context, Receiver receiver, int nameCode, NodeInfo copiedNode)` Callback to output namespace nodes for the new element.
`TailCall` | `processLeavingTail(XPathContext context)` Evaluate the instruction to produce a new element node.
`void` | `processLeft(Stack<XPathContext> contextStack, Stack state)` Process the first half of the instruction in streaming mode
`void` | `processRight(Stack<XPathContext> contextStack, Stack state)` Process the second half of the instruction in streaming mode
`Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.
`Expression` | `typeCheck(ExpressionVisitor visitor, ItemType contextItemType)` Perform type checking of an expression and its subexpressions.

Methods inherited from class net.sf.saxon.expr.instruct.ElementCreator
`checkContentSequence, computeSpecialProperties, getImplementationMethod, isInheritNamespaces, isPreservingTypes, iterateEvents, iterateEvents, processLeavingTail, processLeft, setValidationMode, suppressValidation`

Methods inherited from class net.sf.saxon.expr.instruct.ParentNodeConstructor
`addToPathMap, computeCardinality, createsNewNodes, getBaseURI, getCardinality, getContentExpression, getSchemaType, getValidationMode, isLazyConstruction, isNamespaceSensitive, promoteInst, replaceSubExpression, setBaseURI, setContentExpression, setLazyConstruction, setSchemaType`

Methods inherited from class net.sf.saxon.expr.instruct.Instruction
`assembleParams, assembleTunnelParams, dynamicError, evaluateAsString, getConstructType, getExpressionName, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, iterate, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasLoopingSubexpression, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateSameFocusSubExpressions, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, toString, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### Copy

    public Copy(Expression select,
                boolean copyNamespaces,
                boolean inheritNamespaces,
                SchemaType schemaType,
                int validation)

  Create a shallow copy instruction

  Parameters:
    `select` - selects the node (or other item) to be copied
    `copyNamespaces` - true if namespace nodes are to be copied when copying an element
    `inheritNamespaces` - true if child elements are to inherit the namespace nodes of their parent
    `schemaType` - the Schema type against which the content is to be validated
    `validation` - the schema validation mode

Method Detail

### getSelectExpression

    public Expression getSelectExpression()

  Get the expression that selects the node or other item to be copied

  Returns:
    the select expression

### simplify

    public Expression simplify(ExpressionVisitor visitor)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.

  Overrides:
    `simplify` in class `ParentNodeConstructor`
  Parameters:
    `visitor` - an expression visitor
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### typeCheck

    public Expression typeCheck(ExpressionVisitor visitor,
                                ItemType contextItemType)
                         throws XPathException

  Description copied from class: `Expression`
  Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

  This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

  If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

  Overrides:
    `typeCheck` in class `ParentNodeConstructor`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### copy

    public Expression copy()

  Copy an expression. This makes a deep copy.

  Specified by:
    `copy` in class `Expression`
  Returns:
    the copy of the original expression

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE. The default implementation combines the intrinsic dependencies of this expression with the dependencies of the subexpressions, computed recursively. This is overridden for expressions such as FilterExpression where a subexpression's dependencies are not necessarily inherited by the parent expression.

  Overrides:
    `getIntrinsicDependencies` in class `Expression`
  Returns:
    a set of bit-significant flags identifying the dependencies of the expression

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes

  Overrides:
    `getInstructionNameCode` in class `Instruction`
  Returns:
    a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

### iterateSubExpressions

    public Iterator<Expression> iterateSubExpressions()

  Get the immediate sub-expressions of this expression.

  Overrides:
    `iterateSubExpressions` in class `ParentNodeConstructor`
  Returns:
    an iterator containing the sub-expressions of this expression

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the item type of the result of this instruction.

  Overrides:
    `getItemType` in class `ElementCreator`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    The context item type.

### optimize

    public Expression optimize(ExpressionVisitor visitor,
                               ItemType contextItemType)
                        throws XPathException

  Description copied from class: `Expression`
  Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `ParentNodeConstructor`
  Parameters:
    `visitor` - an expression visitor
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution
  Throws:
    `XPathException` - if an error is discovered during this phase (typically a type error)

### getNameCode

    public int getNameCode(XPathContext context,
                           NodeInfo copiedNode)
                    throws XPathException

  Callback from ElementCreator when constructing an element

  Specified by:
    `getNameCode` in class `ElementCreator`
  Parameters:
    `context` - XPath dynamic evaluation context
    `copiedNode` - the node being copied
  Returns:
    the namecode of the element to be constructed
  Throws:
    `XPathException`

### getNewBaseURI

    public String getNewBaseURI(XPathContext context,
                                NodeInfo copiedNode)

  Get the base URI of a copied element node (the base URI is retained in the new copy)

  Specified by:
    `getNewBaseURI` in class `ElementCreator`
  Parameters:
    `context` - XPath dynamic evaluation context
    `copiedNode` -
  Returns:
    the base URI

### outputNamespaceNodes

    protected void outputNamespaceNodes(XPathContext context,
                                        Receiver receiver,
                                        int nameCode,
                                        NodeInfo copiedNode)
                                 throws XPathException

  Callback to output namespace nodes for the new element.

  Specified by:
    `outputNamespaceNodes` in class `ElementCreator`
  Parameters:
    `context` - The execution context
    `receiver` - the Receiver where the namespace nodes are to be written
    `nameCode` -
    `copiedNode` -
  Throws:
    `XPathException`

### getActiveNamespaces

    public int[] getActiveNamespaces()
                              throws XPathException

  Callback to get a list of the intrinsic namespaces that need to be generated for the element. The result is an array of namespace codes, the codes either occupy the whole array or are terminated by a -1 entry. A result of null is equivalent to a zero-length array.

  Overrides:
    `getActiveNamespaces` in class `ElementCreator`
  Returns:
    an array of namespace codes, the codes either occupy the whole array or are terminated by a -1 entry. A result of null is equivalent to a zero-length array.
  Throws:
    `XPathException`

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Description copied from class: `ElementCreator`
  Evaluate the instruction to produce a new element node. This method is typically used when there is a parent element or document in a result tree, to which the new element is added.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Overrides:
    `processLeavingTail` in class `ElementCreator`
  Parameters:
    `context` - XPath dynamic evaluation context
  Returns:
    null (this instruction never returns a tail call)
  Throws:
    `XPathException`

### evaluateItem

    public Item evaluateItem(XPathContext context)
                      throws XPathException

  Evaluate as an expression. We rely on the fact that when these instructions are generated by XQuery, there will always be a valueExpression to evaluate the content

  Specified by:
    `evaluateItem` in interface `EvaluableItem`
  Overrides:
    `evaluateItem` in class `ElementCreator`
  Parameters:
    `context` - The context in which the expression is to be evaluated
  Returns:
    the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### processLeft

    public void processLeft(Stack<XPathContext> contextStack,
                            Stack state)
                     throws XPathException

  Process the first half of the instruction in streaming mode

  Specified by:
    `processLeft` in interface `DivisibleInstruction`
  Overrides:
    `processLeft` in class `ElementCreator`
  Parameters:
    `contextStack` - the dynamic evaluation context
    `state` - a stack on which the instruction can save state information for use during the corresponding
  Throws:
    `XPathException`

### processRight

    public void processRight(Stack<XPathContext> contextStack,
                             Stack state)
                      throws XPathException

  Process the second half of the instruction in streaming mode

  Specified by:
    `processRight` in interface `DivisibleInstruction`
  Overrides:
    `processRight` in class `ElementCreator`
  Parameters:
    `contextStack` - Stack of XPathContext objects. The instruction should use the one at the top of the stack.
    `state` - a stack on which the instruction can save state information for use during the corresponding
  Throws:
    `XPathException`

### explain

    public void explain(ExpressionPresenter out)

  Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.

  Specified by:
    `explain` in class `Expression`
  Parameters:
    `out` - the expression presenter used to display the structure

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2010 Saxonica Limited. All rights reserved.